
// Vk3DVision (http://3dsurroundgaming.com/) - Original Shader
#version 450
#extension GL_EXT_nonuniform_qualifier : require
#extension GL_ARB_shader_draw_parameters : require
#extension GL_ARB_shader_ballot : require

out float gl_ClipDistance[1];

invariant gl_Position;

struct S_MATRICES
{
    mat4 _mModelViewProj;
    mat4 _mModelViewProjPrevious;
    mat4 _mModelView;
    mat4 _mInvModelView;
};

struct unaligned_float3
{
    float x;
    float y;
    float z;
};

struct S_TBN
{
    int _iNormal;
    int _iTangent;
};

struct S_INDICES
{
    uint _uiObjectIndex;
    uint _uiMaterialIndex;
    uint _uiMaterialInstanceIndex;
    uint _uiLastFrameMaterialIndex;
    uint _uiLastFrameMaterialInstanceIndex;
    uint _uiPositionsBufferIndex;
    uint _uiPrevPositionsBufferIndex;
    uint _uiNormalsBufferIndex;
    uint _uiPositionOffset;
    uint _uiPrevPositionOffset;
    uint _uiNormalOffset;
    uint _uiMatricesIndex;
};

struct S_MAIN_DEFAULT
{
    S_INDICES _Indices;
};

struct S_MAIN_DEFAULT_ARRAY
{
    S_MAIN_DEFAULT _aMain[32];
};

struct S_MESH_OBJECT
{
    mat4 _mModel;
    mat4 _mModelLast;
    mat4 _mInvModel;
    mat4 _mInvModelLast;
    vec4 _vDiversityOffset;
    uint _uiSceneZoneIndex;
    uint _uiNeighborSceneZoneIndex;
    uint _uiDisplayFlags;
    uint _uiPackedLocalExposureCompensation;
    vec4 _vPortalDirAndDistance;
    int _iPickingID[2];
    float _fLocalExposureCompensation;
    float _fLocalExposureCompensationEV100;
};

struct S_MATERIAL
{
    vec4 _vErrorColor;
    float _fDepthBias;
    float _fDummy0;
    float _fDummy1;
    float _fDummy2;
    float c0;
    float c1;
    float c2;
    float c3;
    uint s0;
    uint s1;
    uint s2;
    uint s3;
    uint s4;
    uint s5;
    uint s6;
    uint s7;
    uint s8;
    uint s9;
    uint s10;
    uint s11;
    uint s12;
    uint s13;
    uint s14;
    uint s15;
    uint s16;
    uint s17;
    uint s18;
    uint s19;
};

struct S_MATERIAL_INSTANCE
{
    float c0;
    float c1;
    float c2;
    float c3;
    float c4;
    float c5;
    float c6;
    float c7;
    float _fGloubiboulga;
};

struct S_PASS_MATRICES
{
    mat4 _mViewJitteredProj;
    mat4 _mViewProj;
    mat4 _mView;
    mat4 _mInvView;
    mat4 _mJitteredProj;
};

struct S_EYE_DATA
{
    S_PASS_MATRICES _mCurrentFrameMatrices[2];
    S_PASS_MATRICES _mPreviousFrameMatrices[2];
    mat4 _mJitteredProjection[2];
    mat4 _mNoJitterProjection[2];
    mat4 _mInvViewJitteredProj[2];
    vec4 _vWorldSpaceCameraVector[2];
    vec4 _vWorldSpaceCameraPosition[2];
    vec4 _vFrameBufferScale;
    vec4 _vFrameBufferViewportSize;
    vec4 _vFrameBufferOneOnViewportSize;
    vec4 _vViewportSize;
    vec4 _vFogSubCrop;
    uint _uiAlignment0;
    uint _uiAlignment1;
    float _vCameraJitterDeltaX;
    float _vCameraJitterDeltaY;
    vec4 _vfRcpFVolumetricFogDepthTileSize;
};

struct S_CASCADED_SHADOW
{
    mat4 _mCascadeMatrix[2][8];
    mat4 _mViewSpaceToStaticShadowMapSpace[2];
    vec4 _vfCascadeShadowAttenuation;
    vec4 _vfShadowCascadeTextureTexelSize;
    vec4 _vfStaticShadowBlurRadius;
    vec4 _vfCascadeLinearZProjFactors[8];
    vec4 _vfCascadeParams[8];
};

struct S_CLUSTER_LIGHT_SETUP
{
    S_CASCADED_SHADOW _CascadedShadow;
    vec4 _vfSkinUVParamsAndNormalBias;
    vec4 _vfShadowTextureTexelSize;
    vec4 _vfDummy_SkinFresnelF0AndF90;
    uint _uiCascadedUsed;
    float _fSSSWidth;
    float _fOffsetBias;
    float _fDummy;
};

struct S_CLUSTER_INFO
{
    mat4 _mViewToClusterView[2];
    mat4 _mClusterProjMatrix;
    mat4 _mClusterInvProjMatrix;
    vec4 _vfLeftEyeToCombinedEyeVsDeltaXZ;
    uint _uiFinestMipWidth;
    uint _uiFinestMipHeight;
    uint _uiFinestMipDepth;
    uint _uiFinestMipWidthHeight;
    float _fZSliceGeomFactor;
    float _fRcpLogZSliceGeomFactor;
    float _fDummy0;
    float _fDummy1;
    float _fNearP;
    float _fInvNearP;
    float _fFarP;
    float _fClusterCoincidentWithCamera;
};

struct S_PASS
{
    S_EYE_DATA _EyeData;
    vec4 _avFrustumCorners[4];
    vec4 _vTime;
    vec4 _cFogColor;
    vec4 _vFogSetup;
    vec4 _cSunColor;
    vec4 _vSunDir;
    vec4 _vProjectionSetup;
    vec4 _vProjectionCoeff;
    vec4 _vOutputColor;
    vec4 _vfVsClippingPlane[2];
    S_CLUSTER_LIGHT_SETUP _LightSetup;
    S_CLUSTER_INFO _ClusterInfo;
    float _fIBLIntensity;
    float _fGIIntensity;
    float _fAmbiantOcclusionDirectIntensity;
    float _fAmbiantOcclusionIndirectIntensity;
    float _fNormalSign;
    int _iFogType;
    float _fSelfOcclusionDebugRatio;
    float _fEmissive;
    int _iEnableSkinSSSSS;
    int _iUseHairOpaquePrepass;
    float _fLocalSceneExposure;
    uint _uiDebugMode;
    uint _sFlags;
    float _fTAADropsSharpness;
    uint _uNeoScaleX;
    uint _uNeoScaleY;
    uint _uiDirectOverdrawFilter;
    float _fCoderTest0;
    float _fCoderTest1;
    float _fCoderTest2;
    uint _uiBakeOutput;
    float _fDefaultAmbientIntensity;
    float _fDefaultLightingIntensity;
    uint _uiOutputColor;
    float _fAARotation;
    float _fClampDirectSpecular;
    float _fNearPlane;
    float _fFarPlane;
    float _fNDFFilteringScreenSpaceVariance;
    float _fNDFFilteringThreshold;
    float _fNDFFilteringScreenSpaceVariance_EyeShader;
    float _fNDFFilteringThreshold_EyeShader;
    float _fSurfaceGradientTextureFiltering;
    float _fZero;
    uint _uDepthClamp;
    uint _uiLightDebugMode;
    vec4 _vfFragCoordToDepthTexFactor;
    vec4 _vfFragCoordToDepthTexFactor_HalfRes;
    uint _uHdr;
    uint _uiDrawMayaSwatch;
    float _fEyeRoughnessBias;
    float _fDummy1;
};

layout(set = 1, binding = 24, std430) readonly buffer stc_g_rbMatrices_Layout
{
    S_MATRICES g_rbMatrices[];
} _165;

layout(set = 1, binding = 39, std430) readonly buffer g_rbVertices_Layout
{
    unaligned_float3 g_rbVertices[];
} g_rbVertices_Buffer[];

layout(set = 1, binding = 40, std430) readonly buffer g_rbTBNs_Layout
{
    S_TBN g_rbTBNs[];
} g_rbTBNs_Buffer[];

layout(set = 0, binding = 52, std140) uniform dyn_CONSTANT_BUFFER_BLOCK_CB_S_MAIN_ARRAY_BINDING
{
    S_MAIN_DEFAULT_ARRAY g_cbMainArray;
} _1163;

layout(set = 1, binding = 33, std430) readonly buffer g_rbObjects_Layout
{
    S_MESH_OBJECT g_rbObjects[];
} g_rbObjects_Buffer[];

layout(set = 1, binding = 34, std430) readonly buffer g_rbMaterials_Layout
{
    S_MATERIAL g_rbMaterials[];
} g_rbMaterials_Buffer[];

layout(set = 1, binding = 35, std430) readonly buffer g_rbMaterialInstances_Layout
{
    S_MATERIAL_INSTANCE g_rbMaterialInstances[];
} g_rbMaterialInstances_Buffer[];

layout(set = 2, binding = 53, std140) uniform dyn_CONSTANT_BUFFER_BLOCK_CB_S_PASS_BINDING
{
    S_PASS g_cbPass;
} _1458;

layout(set = 1, binding = 12) uniform sampler2D g_rb2DTextures[];

layout(location = 8) in vec2 in_uv0;
layout(location = 23) out float interp_instanceID;

vec3 _8162;

void main()
{
    int _1153 = gl_InstanceIndex + gl_DrawIDARB;
    int _1154 = readFirstInvocationARB(_1153);
    uint _3115 = uint(gl_VertexIndex);
    uint _3118 = _3115 + _1163.g_cbMainArray._aMain[_1154]._Indices._uiPositionOffset;
    vec4 _3131 = vec4(g_rbVertices_Buffer[_1163.g_cbMainArray._aMain[_1154]._Indices._uiPositionsBufferIndex].g_rbVertices[_3118].x, g_rbVertices_Buffer[_1163.g_cbMainArray._aMain[_1154]._Indices._uiPositionsBufferIndex].g_rbVertices[_3118].y, g_rbVertices_Buffer[_1163.g_cbMainArray._aMain[_1154]._Indices._uiPositionsBufferIndex].g_rbVertices[_3118].z, 1.0);
    uint _3138 = _3115 + _1163.g_cbMainArray._aMain[_1154]._Indices._uiNormalOffset;
    int _3167 = g_rbTBNs_Buffer[_1163.g_cbMainArray._aMain[_1154]._Indices._uiNormalsBufferIndex].g_rbTBNs[_3138]._iNormal & 1023;
    int _3170 = (g_rbTBNs_Buffer[_1163.g_cbMainArray._aMain[_1154]._Indices._uiNormalsBufferIndex].g_rbTBNs[_3138]._iNormal >> 10) & 1023;
    int _3173 = (g_rbTBNs_Buffer[_1163.g_cbMainArray._aMain[_1154]._Indices._uiNormalsBufferIndex].g_rbTBNs[_3138]._iNormal >> 20) & 1023;
    int _8149;
    if (_3167 > 512)
    {
        _8149 = _3167 | (-1024);
    }
    else
    {
        _8149 = _3167;
    }
    int _8151;
    if (_3170 > 512)
    {
        _8151 = _3170 | (-1024);
    }
    else
    {
        _8151 = _3170;
    }
    int _8153;
    if (_3173 > 512)
    {
        _8153 = _3173 | (-1024);
    }
    else
    {
        _8153 = _3173;
    }
    float _3216 = float(_8149);
    float _3219 = float(_8151);
    float _3222 = float(_8153);
    vec3 _3223 = vec3(_3216, _3219, _3222);
    vec3 _3226 = _3223 * vec3(0.001956947147846221923828125);
    vec3 _3316 = _3131.xyz;
    mat3 _3508 = mat3(g_rbObjects_Buffer[_1163.g_cbMainArray._aMain[_1154]._Indices._uiObjectIndex].g_rbObjects[0]._mModel[0].xyz, g_rbObjects_Buffer[_1163.g_cbMainArray._aMain[_1154]._Indices._uiObjectIndex].g_rbObjects[0]._mModel[1].xyz, g_rbObjects_Buffer[_1163.g_cbMainArray._aMain[_1154]._Indices._uiObjectIndex].g_rbObjects[0]._mModel[2].xyz);
    vec3 _3511 = _3508 * _3226;
    vec2 _3743 = in_uv0 * vec2(3.0);
    vec3 _8092 = _8162;
    _8092.y = textureLod(g_rb2DTextures[g_rbMaterials_Buffer[_1163.g_cbMainArray._aMain[_1154]._Indices._uiMaterialIndex].g_rbMaterials[0].s8], _3743 + vec2(0.0500000007450580596923828125, -0.1500000059604644775390625), 0.0).x;
    vec3 _3761 = vec3(g_rbMaterialInstances_Buffer[_1163.g_cbMainArray._aMain[_1154]._Indices._uiMaterialInstanceIndex].g_rbMaterialInstances[0].c0);
    vec3 _3766 = _3761 * vec3(0.100000001490116119384765625, 0.00999999977648258209228515625, 0.001000000047497451305389404296875);
    vec3 _3769 = trunc(_3766);
    vec3 _3773 = _3769 * vec3(10.0, 100.0, 1000.0);
    vec3 _3777 = _3761 - _3773;
    vec3 _3781 = _3777 * vec3(1.0, 0.100000001490116119384765625, 0.00999999977648258209228515625);
    vec3 _3784 = trunc(_3781);
    float _3786 = _3784.x;
    vec3 _3790 = vec3(_3786);
    vec3 _3791 = mix(vec3(0.0), _8092, _3790);
    vec3 _8102 = _8162;
    _8102.y = textureLod(g_rb2DTextures[g_rbMaterials_Buffer[_1163.g_cbMainArray._aMain[_1154]._Indices._uiMaterialIndex].g_rbMaterials[0].s8], _3743 + vec2(-0.5, -0.300000011920928955078125), 0.0).y;
    float _3818 = _3784.y;
    vec3 _3822 = vec3(_3818);
    vec3 _3823 = mix(vec3(0.0), _8102, _3822);
    vec3 _3827 = vec3(1.0) - _3791;
    vec3 _3830 = vec3(1.0) - _3823;
    vec3 _3831 = _3827 * _3830;
    vec3 _8112 = _8162;
    _8112.y = textureLod(g_rb2DTextures[g_rbMaterials_Buffer[_1163.g_cbMainArray._aMain[_1154]._Indices._uiMaterialIndex].g_rbMaterials[0].s8], (in_uv0 * vec2(2.0)) + vec2(0.0, 0.20000000298023223876953125), 0.0).z;
    float _3860 = _3784.z;
    vec3 _3864 = vec3(_3860);
    vec3 _3865 = mix(vec3(0.0), _8112, _3864);
    vec3 _3872 = vec3(1.0) - _3865;
    vec3 _3873 = _3831 * _3872;
    vec3 _3875 = vec3(1.0) - _3873;
    float _3883 = _3875.y;
    float _3888 = _3883 - 0.77499997615814208984375;
    float _3893 = _3888 * 99.89960479736328125;
    float _3894 = clamp(_3893, 0.0, 1.0);
    float _3895 = mix(0.0, 1.0, _3894);
    float _3903 = _3883 - 0.20000000298023223876953125;
    float _3908 = _3903 * 3.333221912384033203125;
    float _3909 = clamp(_3908, 0.0, 1.0);
    float _3910 = mix(0.0, 1.0, _3909);
    vec3 _3915 = vec3(_3910);
    vec3 _3916 = mix(vec3(0.0), vec3(0.01002299971878528594970703125), _3915);
    vec3 _3921 = vec3(_3895);
    vec3 _3922 = mix(_3916, vec3(-0.015479999594390392303466796875), _3921);
    vec3 _3928 = _3922 * _3511;
    vec3 _3936 = vec3(g_rbMaterialInstances_Buffer[_1163.g_cbMainArray._aMain[_1154]._Indices._uiMaterialInstanceIndex].g_rbMaterialInstances[0].c1);
    vec3 _3937 = mix(vec3(0.0), _3928, _3936);
    vec3 _3961 = _3316 + _3937;
    float _4087 = _3961.x;
    float _4088 = _3961.y;
    float _4089 = _3961.z;
    vec4 _4090 = vec4(_4087, _4088, _4089, 1.0);
    vec4 _4091 = _165.g_rbMatrices[_1163.g_cbMainArray._aMain[_1154]._Indices._uiMatricesIndex]._mModelView * _4090;
    vec4 _4110 = _165.g_rbMatrices[_1163.g_cbMainArray._aMain[_1154]._Indices._uiMatricesIndex]._mModelViewProj * _4090;
    vec4 _8159;
    if (_1458.g_cbPass._uDepthClamp == 4294967295u)
    {
        float _4144 = _4110.w;
        vec4 _8160;
        if ((_4110.z / _4144) > 1.0)
        {
            vec4 _8161;
            if (_4091.z > _1458.g_cbPass._fNearPlane)
            {
                vec4 _8126 = _4110;
                _8126.z = _4144;
                _8161 = _8126;
            }
            else
            {
                _8161 = _4110;
            }
            _8160 = _8161;
        }
        else
        {
            _8160 = _4110;
        }
        _8159 = _8160;
    }
    else
    {
        _8159 = _4110;
    }
    interp_instanceID = float(_1153) + 0.5;
    float _3001 = _4091.x;
    float _3002 = _4091.y;
    float _3003 = _4091.z;
    vec4 _3004 = vec4(_3001, _3002, _3003, 1.0);
    float _3005 = dot(_1458.g_cbPass._vfVsClippingPlane[0], _3004);
    float _3006 = -_3005;
    gl_ClipDistance[0] = _3006;
    gl_Position = _8159;
}

